## ros-humble-system-modes 0.9.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5)
project(system_modes)

# Default to C99
if(NOT CMAKE_C_STANDARD)
  set(CMAKE_C_STANDARD 99)
endif()

# Default to C++14
if(NOT CMAKE_CXX_STANDARD)
  set(CMAKE_CXX_STANDARD 14)
endif()

if(CMAKE_COMPILER_IS_GNUCXX OR CMAKE_CXX_COMPILER_ID MATCHES "Clang")
  add_compile_options(-Wall -Wextra -Wpedantic)
endif()

# find dependencies
find_package(ament_cmake REQUIRED)
find_package(builtin_interfaces REQUIRED)
find_package(rclcpp REQUIRED)
find_package(rcl_lifecycle REQUIRED)
find_package(rclcpp_lifecycle REQUIRED)
find_package(rosidl_typesupport_cpp REQUIRED)
find_package(lifecycle_msgs REQUIRED)
find_package(system_modes_msgs REQUIRED)

add_library(mode SHARED
  src/system_modes/mode.cpp
  src/system_modes/mode_impl.cpp
  src/system_modes/mode_handling.cpp
  src/system_modes/mode_inference.cpp
  src/system_modes/mode_observer.cpp)
target_include_directories(mode PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
ament_target_dependencies(mode
  "rclcpp"
  "rcl_lifecycle"
  "rclcpp_lifecycle"
  "rosidl_typesupport_cpp"
  "lifecycle_msgs"
  "system_modes_msgs"
)

# Causes the visibility macros to use dllexport rather than dllimport,
# which is appropriate when building the dll but not consuming it.
target_compile_definitions(mode PRIVATE "SYSTEMMODES_BUILDING_LIBRARY")

install(
  DIRECTORY include/
  DESTINATION include
)
install(
  TARGETS mode
  ARCHIVE DESTINATION lib
  LIBRARY DESTINATION lib
  RUNTIME DESTINATION bin
)

# mode manager
add_executable(mode_manager src/system_modes/mode_manager.cpp
                            src/mode_manager_node.cpp)
target_include_directories(mode_manager PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(mode_manager mode)
install(TARGETS mode_manager
  DESTINATION lib/${PROJECT_NAME})

# mode monitor
add_executable(mode_monitor src/system_modes/mode_monitor.cpp
                            src/mode_monitor_node.cpp)
target_include_directories(mode_monitor PUBLIC
  $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
  $<INSTALL_INTERFACE:include>)
target_link_libraries(mode_monitor mode)
install(TARGETS mode_monitor
  DESTINATION lib/${PROJECT_NAME})

  # launch
install(DIRECTORY launch DESTINATION share/${PROJECT_NAME}/)

if(BUILD_TESTING)
  find_package(ament_lint_auto REQUIRED)
  find_package(ament_cmake_gtest REQUIRED)
  find_package(ament_cmake_gmock REQUIRED)
  # the following line skips the linter which checks for copyrights
  # remove the line when a copyright and license is present in all source files
  set(ament_cmake_copyright_FOUND TRUE)
  ament_lint_auto_find_test_dependencies()

  set(MODE_FILE_CORRECT ${CMAKE_CURRENT_SOURCE_DIR}/test/test_modes.yaml)
  set(MODE_FILE_RULES ${CMAKE_CURRENT_SOURCE_DIR}/test/test_modes_rules.yaml)
  set(MODE_FILE_WRONG ${CMAKE_CURRENT_SOURCE_DIR}/test/test_modes_wrong.yaml)
  configure_file(test/modefiles.h.in ${CMAKE_CURRENT_BINARY_DIR}/system_modes/modefiles.h)
  include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR})

  # Unit Tests
  ament_add_gtest(test_state_and_mode_struct test/test_state_and_mode_struct.cpp)
  if(TARGET test_state_and_mode_struct)
    target_include_directories(test_state_and_mode_struct PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_state_and_mode_struct mode)
  endif()

  ament_add_gtest(test_default_mode test/test_default_mode.cpp)
  if(TARGET test_default_mode)
    target_include_directories(test_default_mode PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_default_mode mode)
  endif()

  ament_add_gtest(test_mode test/test_mode.cpp)
  if(TARGET test_mode)
    target_include_directories(test_mode PUBLIC
      ${rclcpp_INCLUDE_DIRS}
    )
    target_link_libraries(test_mode mode)
  endif()

  ament_add_gtest(test_mode_inference test/test_mode_inference.cpp)
  if(TARGET test_mode_inference)
    target_include_directories(test_mode_inference PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_inference mode)
  endif()

  ament_add_gtest(test_mode_handling test/test_mode_handling.cpp)
  if(TARGET test_mode_handling)
    target_include_directories(test_mode_handling PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_handling mode)
  endif()

  ament_add_gtest(test_mode_manager
    test/test_mode_manager.cpp
    src/system_modes/mode_manager.cpp)
  if(TARGET test_mode_manager)
    target_include_directories(test_mode_manager PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_manager mode)
  endif()

  ament_add_gtest(test_mode_monitor
    test/test_mode_monitor.cpp
    src/system_modes/mode_monitor.cpp)
  if(TARGET test_mode_monitor)
    target_include_directories(test_mode_monitor PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_monitor mode)
  endif()

  ament_add_gtest(test_mode_observer test/test_mode_observer.cpp)
  if(TARGET test_mode_observer)
    target_include_directories(test_mode_observer PUBLIC
      ${rclcpp_INCLUDE_DIRS}
      ${CMAKE_CURRENT_BINARY_DIR}/system_modes/
    )
    target_link_libraries(test_mode_observer mode)
  endif()

  # mode observer test node
  add_executable(modes_observer_test_node test/launchtest/modes_observer_test_node.cpp)
  target_include_directories(modes_observer_test_node PUBLIC
    $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>
    $<INSTALL_INTERFACE:include>)
  target_link_libraries(modes_observer_test_node mode)
  install(TARGETS modes_observer_test_node DESTINATION lib/${PROJECT_NAME})

  # Launch Tests
  find_package(launch_testing_ament_cmake REQUIRED)
  set(launch_tests
    "two_lifecycle_nodes"           # Mode Manager with Lifecycle Nodes
    "two_mixed_nodes"               # Mode Manager with Lifecycle and non-Lifecycle Nodes
    "two_independent_hierarchies"   # Mode Manager for two independent hierarchies of nodes
    "manager_and_monitor"           # Mode Manager and Mode Monitor
    "redundant_mode_changes"        # Ignore redundant mode changes
    "modes_observer")               # Mode Observer

  # Launch Test: Mode Manager with Lifecycle Nodes
  foreach(test_name ${launch_tests})
    file(TO_CMAKE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/test/launchtest/${test_name}.py" TEST_NODES)
    file(TO_CMAKE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/test/launchtest/${test_name}_modes.yaml" MODELFILE)
    file(TO_CMAKE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/test/launchtest/${test_name}_expected_output" EXPECTED_OUTPUT)
    configure_file(
        "test/launchtest/${test_name}.launch.py.in"
        "test/${test_name}.launch.py"
        @ONLY
      )
    add_launch_test(
      "${CMAKE_CURRENT_BINARY_DIR}/test/${test_name}.launch.py"
      TARGET "${test_name}"
      TIMEOUT 30
      ENV
    )
  endforeach()
endif()

ament_export_include_directories(include)
ament_export_libraries(mode)
ament_export_dependencies(rclcpp)
ament_export_dependencies(rclcpp_lifecycle)
ament_export_dependencies(lifecycle_msgs)
ament_export_dependencies(system_modes_msgs)
ament_package()

=== debian/changelog ===
ros-humble-system-modes (0.9.0-6jammy) jammy; urgency=high

  * More flexibility in specifying the default mode, any mode can be now default mode
    https://github.com/micro-ROS/system_modes/issues/69

 -- Arne Nordmann <arne.nordmann@bosch.com>  Mon, 20 Jul 2020 22:00:00 -0000

ros-humble-system-modes (0.8.0-6jammy) jammy; urgency=high

  * Launch integration, i.e. launch actions, events, and event handlers for system modes

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes (0.7.1-6jammy) jammy; urgency=high

  * Improved metadata for ROS 2 package releases

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes (0.7.0-6jammy) jammy; urgency=high

  * Launch tests now using launch_ros node action https://github.com/micro-ROS/system_modes/pull/72
  * Introduced separate interface package, system_modes_msgs https://github.com/micro-ROS/system_modes/pull/74

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 21 Apr 2020 22:00:00 -0000

ros-humble-system-modes (0.6.0-6jammy) jammy; urgency=high

  * Introduced mode observer https://github.com/micro-ROS/system_modes/issues/59
  * Mode manager prevents redundant mode changes https://github.com/micro-ROS/system_modes/pull/67
  * Minor bugfix in inference

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 15 Mar 2020 23:00:00 -0000

ros-humble-system-modes (0.5.0-6jammy) jammy; urgency=high

  * Atomic parameter setting https://github.com/micro-ROS/system_modes/issues/59
  * Bug fixing
  * More tests

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 15 Mar 2020 23:00:00 -0000

ros-humble-system-modes (0.4.2-6jammy) jammy; urgency=high

  * Error handling and rules feature no longer experimental
  * Fixed bugs in monitor and tests

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 16 Dec 2020 23:00:00 -0000

ros-humble-system-modes (0.4.1-6jammy) jammy; urgency=high

  * Include experimental error handling and rules feature
  * https://github.com/micro-ROS/system_modes/issues/13
  * CI for ubuntu 20.04 ROS 2 rolling

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 28 Oct 2020 23:00:00 -0000

ros-humble-system-modes (0.4.0-6jammy) jammy; urgency=high

  * publish inferred state and mode transitions
  * https://github.com/micro-ROS/system_modes/issues/42

 -- Arne Nordmann <arne.nordmann@bosch.com>  Tue, 29 Sep 2020 22:00:00 -0000

ros-humble-system-modes (0.3.0-6jammy) jammy; urgency=high

  * removed boost dependencies (was: program options)
  * changed mode service specifications (less redundancy)
  * https://github.com/micro-ROS/system_modes/issues/24

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 22 Jul 2020 22:00:00 -0000

ros-humble-system-modes (0.2.3-6jammy) jammy; urgency=high

  * improved StateAndMode struct
  * testing

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 22 Jul 2020 22:00:00 -0000

ros-humble-system-modes (0.2.2-6jammy) jammy; urgency=high

  * introduced StateAndMode struct to bundle lifecycle state and system mode

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 12 Jul 2020 22:00:00 -0000

ros-humble-system-modes (0.2.0-6jammy) jammy; urgency=high

  * integration with ROS 2 launch
  * updated docs

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 12 Feb 2020 23:00:00 -0000

ros-humble-system-modes (0.1.6-6jammy) jammy; urgency=high

  * fixed QoS configuration for parameter event subscribers

 -- Arne Nordmann <arne.nordmann@bosch.com>  Wed, 30 Oct 2019 23:00:00 -0000

ros-humble-system-modes (0.1.2-6jammy) jammy; urgency=high

  * fixed dependencies in package.xml

 -- Arne Nordmann <arne.nordmann@bosch.com>  Sun, 17 Mar 2019 23:00:00 -0000

ros-humble-system-modes (0.1.1-6jammy) jammy; urgency=high

  * first public release for ROS 2 system modes

 -- Arne Nordmann <arne.nordmann@bosch.com>  Thu, 07 Mar 2019 23:00:00 -0000

=== debian/control ===
Source: ros-humble-system-modes
Section: misc
Priority: optional
Maintainer: Arne Nordmann <arne.nordmann@bosch.com>
Build-Depends: debhelper (>= 9.0.0), ros-humble-ament-cmake, ros-humble-ament-cmake-cppcheck <!nocheck>, ros-humble-ament-cmake-cpplint <!nocheck>, ros-humble-ament-cmake-flake8 <!nocheck>, ros-humble-ament-cmake-gmock <!nocheck>, ros-humble-ament-cmake-gtest <!nocheck>, ros-humble-ament-cmake-pep257 <!nocheck>, ros-humble-ament-cmake-uncrustify <!nocheck>, ros-humble-ament-index-python <!nocheck>, ros-humble-ament-lint-auto <!nocheck>, ros-humble-builtin-interfaces, ros-humble-launch-testing-ament-cmake <!nocheck>, ros-humble-launch-testing-ros <!nocheck>, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-ros2run <!nocheck>, ros-humble-system-modes-msgs, ros-humble-ros-workspace
Homepage: https://micro.ros.org/docs/concepts/client_library/lifecycle_and_system_modes/
Standards-Version: 3.9.2

Package: ros-humble-system-modes
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, ros-humble-builtin-interfaces, ros-humble-launch-ros, ros-humble-rclcpp, ros-humble-rclcpp-lifecycle, ros-humble-system-modes-msgs, ros-humble-ros-workspace
Description: The system modes concept assumes that a robotics system is built from components with a lifecycle.
 It adds a notion of (sub-)systems, hiararchically grouping these nodes, as well as a notion of modes that determine the configuration of these nodes and (sub-)systems in terms of their parameter values.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/humble/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG
ifneq ($(filter nocheck,$(DEB_BUILD_OPTIONS)),)
	BUILD_TESTING_ARG=-DBUILD_TESTING=OFF
endif

DEB_HOST_GNU_TYPE ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)

%:
	dh $@ -v --buildsystem=cmake --builddirectory=.obj-$(DEB_HOST_GNU_TYPE)

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_configure -- \
		-DCMAKE_INSTALL_PREFIX="/opt/ros/humble" \
		-DAMENT_PREFIX_PATH="/opt/ros/humble" \
		-DCMAKE_PREFIX_PATH="/opt/ros/humble" \
		$(BUILD_TESTING_ARG)

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-humble-system-modes//opt/ros/humble/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree and source it.  It will set things like
	# CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/humble/setup.sh" ]; then . "/opt/ros/humble/setup.sh"; fi && \
	dh_auto_install
